package cn.com.ty.lift.business.framework.conf;

import cn.com.ty.lift.common.constants.ApiConstants;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.time.LocalDateTime;
import java.util.Objects;

/**
 * @author bieao
 * @date 2019/12/23
 * @description 公共字段配置
 */
@Component
public class MetaHandler implements MetaObjectHandler {

    private static final String CREATE_ID = "createId";
    private static final String CREATE_TIME = "createTime";
    private static final String UPDATE_ID = "updateId";
    private static final String UPDATE_TIME = "updateTime";
    private static final String DELETE_FLAG = "deleteFlag";
    private static final String DELETED_VALUE = "1";

    @Override
    public void insertFill(MetaObject metaObject) {
        LocalDateTime now = LocalDateTime.now();
        //获取当前登陆用户id
        Long userId = getUserId();
        if (ObjectUtil.isEmpty(this.getFieldValByName(CREATE_ID, metaObject))) {
            this.setFieldValByName(CREATE_ID, userId, metaObject);
        }
        if (ObjectUtil.isEmpty(this.getFieldValByName(CREATE_TIME, metaObject))) {
            this.setFieldValByName(CREATE_TIME, now, metaObject);
        }
        if (ObjectUtil.isEmpty(this.getFieldValByName(UPDATE_ID, metaObject))) {
            this.setFieldValByName(UPDATE_ID, userId, metaObject);
        }
        if (ObjectUtil.isEmpty(this.getFieldValByName(UPDATE_TIME, metaObject))) {
            this.setFieldValByName(UPDATE_TIME, now, metaObject);
        }
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        //获取当前登陆用户id
        Long userId = getUserId();
        if (ObjectUtil.isEmpty(this.getFieldValByName(UPDATE_ID, metaObject))) {
            this.setFieldValByName(UPDATE_ID, userId, metaObject);
        }
        if (ObjectUtil.isEmpty(this.getFieldValByName(UPDATE_ID, metaObject))) {
            LocalDateTime now = LocalDateTime.now();
            this.setFieldValByName(UPDATE_ID, now, metaObject);
        }
        if (ObjectUtil.isEmpty(this.getFieldValByName(DELETE_FLAG, metaObject))) {
            this.setFieldValByName(DELETE_FLAG, DELETED_VALUE, metaObject);
        }
    }

    private Long getUserId() {
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes())
                .getRequest();
        HttpSession session = request.getSession();
        Object userId = session.getAttribute(ApiConstants.CURRENT_USER);
        return Long.parseLong(Objects.toString(userId));
    }
}
