package cn.com.ty.lift.system.user.service;

import cn.com.ty.lift.system.user.dao.entity.UserAccount;
import cn.com.ty.lift.system.user.dao.entity.model.UserRequest;
import cn.com.ty.lift.system.user.dao.entity.model.UserResponse;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;
import java.util.Map;

/**
 * <h1>.</h1><BR>
 * @author huangyuan - 2019-11-25 18:36:53
 */
public interface IUserService{
    /**
     * @description  用户注册
     * @date 2019/11/27 10:03 AM
     * @param userRequest 用户请求对象
     * @return
     */
    UserAccount saveUserInfo(UserRequest userRequest);

    /**
     * @description 获取用户列表信息
     * @date 2019/11/27 10:03 AM
     * @param userRequest 用户请求参数对象
     * @return
     */
    IPage<UserAccount> list(UserRequest userRequest);

    /**
     * @description 添加用户
     * @date 2019/11/27 10:03 AM
     * @param userRequest 用户请求参数对象
     * @return
     */
    RestResponse addUser(UserRequest userRequest);

    /**
     * @description 更新用户信息
     * @date 2019/11/27 10:03 AM
     * @param userRequest 用户请求参数对象
     * @return
     */
    RestResponse updateUser(UserRequest userRequest);

    /**
     * @description 删除用户信息
     * @date 2019/11/27 10:03 AM
     * @param userRequest 用户请求参数对象
     * @return
     */
    RestResponse deleteUser(UserRequest userRequest);

    /**
     * @description 获取登录的用户信息
     * @date 2019-12-10
     * @param userId 用户id
     * @return
     */
    UserResponse getLoginUserInfo(Long userId);

    /**
     * @description 通过用户id集合获取用户基础信息
     * @date  10:35
     * @param
     * @return
     */
    Map<Long, UserResponse> getUserResponseByUserIdList(List<Long> userIdList);
}
